﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.3
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public AppName As String = "HTMLEditorWrapper - B4J"
	Public JopView As String = "Print preview"
	Public hew As HTMLEditorWrapper
End Sub

'Get the correct printer name
Public Sub GetPrinter(PrinterName As String) As Printer
	Dim Printers As List = Printer_Static.GetAllPrinters
	For Each P As Printer In Printers
		If P.GetName.StartsWith(PrinterName) Then Return P
	Next
	Return Null
End Sub

'Lost all printers on the computer
Public Sub ListAllPrinters() As List
	Dim PrList As List = Printer_Static.GetAllPrinters
	Dim PrNames As List
	PrNames.Initialize
	
	For Each Pr As Printer In PrList
		PrNames.Add(Pr.GetName)
	Next
	Return PrNames
End Sub

'Print the document 
'Has to be resumable sub for safe continuous printing of multiple documents at once.

'Example on how to use:
'SharedCode.PrintToJob(MainForm, False, "Bullzip PDF Printer", True).
'(Main Form, Show printer dialog, Select the printer name, Set for A4 paper or Letter paper size).
Public Sub PrintToJob(MainForm As Form, ShowPrinterDialog As Boolean, PrinterName As String, UsingA4Paper As Boolean, Lbl As Label) As ResumableSub
	If ShowPrinterDialog Then 'Print with dialogs
		Dim PJ As PrinterJob = PrinterJob_Static.CreatePrinterJob
		Dim JS As JobSettings = PJ.GetJobSettings
		If hew.JobName = "" Then hew.JobName = "New 1"
		JS.SetJobName(hew.JobName)
		If PJ.ShowPageSetupDialog(Null) = False Then
			PJ.CancelJob
			hew.HERequestFocus
			Return False
		End If
		If PJ.ShowPrintDialog(Null) = False Then
			PJ.CancelJob
			hew.HERequestFocus
			Return False
		End If
		PJ.PrintPage(MainForm.RootPane)
		If PJ.EndJob Then
			Dim myClipBoard As JavaObject
			myClipBoard.InitializeStatic("javafx.scene.input.Clipboard")
			myClipBoard.RunMethodJO("getSystemClipboard",Null).RunMethod("clear",Null)
			Main.xui.Msgbox2Async("File: "&hew.JobName&CRLF&"Successfully spooleded to the printer queue.", "Printer Job","OK","","",Null)
		End If
		MainForm.Close
	Else 'Setup printer and print without dialogs
		Dim PA As Paper
		PA.Initialize()

		If UsingA4Paper Then PA = Paper_static.A4 Else PA = Paper_static.NA_LETTER
		
		If PrinterName = "" Then
			Private PR As Printer
			PR.Initialize()
			PR = Printer_Static.GetDefaultPrinter
		Else
			Private PR As Printer = GetPrinter(PrinterName)
		End If

		Private PL As PageLayout
		PL.Initialize()
		PL = PR.CreatePageLayout2(PA, PageOrientation_Static.PORTRAIT, "DEFAULT") '"HARDWARE_MINIMUM")
		
		Lbl.PrefWidth = Lbl.PrefWidth - PL.GetLeftMargin - PL.GetRightMargin
		
		Private PJ As PrinterJob = PrinterJob_Static.CreatePrinterJob2(PR)
		Dim JS As JobSettings = PJ.GetJobSettings
		If hew.JobName = "" Then hew.JobName = "New 1"
		JS.SetJobName(hew.JobName)
		PJ.PrintPage2(PL, MainForm.RootPane)
		If PJ.EndJob Then
			Dim myClipBoard As JavaObject
			myClipBoard.InitializeStatic("javafx.scene.input.Clipboard")
			myClipBoard.RunMethodJO("getSystemClipboard",Null).RunMethod("clear",Null)
			Main.xui.Msgbox2Async("File: "&hew.JobName&CRLF&"Successfully spooleded to the printer queue.", "Printer Job","OK","","",Null)
		End If
		MainForm.Close
	End If
	Return Null
End Sub
